{$H+}
unit K351;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, K352;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Button4: TButton;
    Error: TPanel;
    ListBox1: TListBox;
    Memo1: TMemo;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TABC = set of Char;
  TnoABC = set of Char;

var
  Form1 : TForm1;
  Path : string = '';
  DictName : string = 'dict.txt';
  Param : Boolean;
  ABC : TABC;
  noABC : TnoABC;

implementation

{$R *.DFM}

var
  CountWord, CountLine : Integer;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

function IsInDict(InWord : string) : Boolean;
var
  J : Integer;
begin
  Application.ProcessMessages;
  Result := False;
  Form1.Error.Caption := 'dka : ' + IntToStr(CountLine) + ' / Slovo : ' + IntToStr(CountWord);
  for J := 0 to Form1.ListBox1.Items.Count-1 do
    begin
      Application.ProcessMessages;
      if AnsiUpperCase(Form1.ListBox1.Items[J]) = AnsiUpperCase(InWord) then
        begin
          Result := True;
          Break;
        end;
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  InFile, OutFile : TextFile;
  Line, S, InWord, NewLine, OtherChars, noChars : string;
  I, J, L, From : Integer;
  WordFound, MyWord : Boolean;
  SepChar,ZalChar : AnsiChar;
begin
  Edit1.Enabled := False;
  Edit2.Enabled := False;
  Button4.Enabled := False;
  S := Edit1.Text;
  if FileExists(S) = False then
    begin
      S := Path + Edit1.Text;
      if FileExists(S) = False then
        begin
          ShowMessage(S);
          Error.Caption := 'Vstupn soubor neexistuje !!!!';
          Beep;
          Exit;
        end;
    end;
  AssignFile(InFile,Path + Edit1.Text);
  AssignFile(OutFile,Path + Edit2.Text);
  Reset(InFile);
  ReWrite(OutFile);

  CountWord := 0;
  CountLine := 0;
  MyWord := False;
  ZalChar := ' ';
  SepChar := #0;
  while not Eof(InFile) do
    begin
      Application.ProcessMessages;
      noChars := '';
      From := 0;
      NewLine := '';
      ReadLn(InFile,Line);
{      if Line[Length(Line)] in ABC then
        Line := Line + ' '
      else
        Line := Line + 'a';}
      Inc(CountLine);
      CountWord := 0;
      InWord := '';
      L := 0;
      L := Length(Line);
      Error.Caption := 'dka : ' + IntToStr(CountLine) + ' / Slovo : ' + IntToStr(CountWord);
      for I := 1 to L do
        begin
          Application.ProcessMessages;
          SepChar := Line[I];
          if SepChar in ABC then
            begin
              InWord := InWord + Line[I];
              MyWord := False;
            end
          else
            begin
              noChars := noChars + Line[I];
              MyWord := True;
            end;
          if ((MyWord = True) and (InWord <> '')) or (I = L) then
            begin
              if I = L then
                begin
                  if SepChar <> #0 then
                    begin
                      Delete(noChars,Length(noChars),1);
                      if not (SepChar in ABC) then
                        begin
                          NewLine := NewLine + noChars + InWord + SepChar;
                        end
                      else
                        NewLine := NewLine + noChars + InWord;
                    end;
                end
              else
                begin
                  Inc(CountWord);
                  WordFound := IsInDict(InWord);
                  if WordFound = False then
                    begin
                      if CheckBox1.Checked = True then
                        begin
                          K352.Form2.Edit1.Text := InWord;
                          K352.Form2.Edit2.Text := '#' + InWord;
                          if K352.Form2.CheckBox1.Checked = True then
                            begin
                              K352.Form2.ListBox1.Items.Clear;
                              for J := 0 to ListBox1.Items.Count-1 do
                                begin
                                  if ListBox1.Items[J][1] = InWord[1] then
                                    if ListBox1.Items[J][2] = InWord[2] then
                                      K352.Form2.ListBox1.Items.Add(ListBox1.Items[J]);
                                end;
                              if K352.Form2.ListBox1.Items.Count = 0 then
                                for J := 0 to ListBox1.Items.Count-1 do
                                  begin
                                    if ListBox1.Items[J][1] = InWord[1] then
                                      K352.Form2.ListBox1.Items.Add(ListBox1.Items[J]);
                                  end;
                            end
                          else
                            K352.Form2.ListBox1.Items.Clear;
                          K352.Form2.ShowModal;
                          if K352.OS = True then
                            InWord := K352.Form2.Edit2.Text
                          else
                            InWord := '#' + InWord;
                        end
                      else
                        begin
                          InWord := '#' + InWord;
                        end;
                    end;
                  Delete(noChars,Length(noChars),1);
                  NewLine := NewLine + noChars + InWord + SepChar;
                end;
              InWord := '';
              noChars := '';
            end;
        end;
       Memo1.Lines.Add('IN : ' + Line);
       Memo1.Lines.Add('OUT : ' + NewLine);
       WriteLn(OutFile,NewLine);
    end;

  CloseFile(InFile);
  CloseFile(OutFile);
  Error.Caption := '';
  Button4.Enabled := True;
  Edit1.Enabled := True;
  Edit2.Enabled := True;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  DictFile : TextFile;
  Line : string;
  I : Integer;
begin
  Edit1.Enabled := False;
  Edit2.Enabled := False;
  Button4.Enabled := False;
  AssignFile(DictFile,Path + DictName);
  Reset(Dictfile);
  Error.Caption := 'Natm slovnk ...';
  while not Eof(DictFile) do
    begin
      Application.ProcessMessages;
      ReadLn(DictFile,Line);
      I := Pos('/',Line);
      if I <> 0 then
        begin
          Line := Copy(Line,0,I-1);
        end;
      Line := Trim(Line);
      ListBox1.Items.Add(Line);
    end;
  Error.Caption := 'Slovnk naten.';
  CloseFile(DictFile);
  if Param = True then
    begin
      Button4.Click;
      Close;
    end;
  Button4.Enabled := True;
  Edit1.Enabled := True;
  Edit2.Enabled := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ABC := ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q',
    'R','S','T','U','V','W','X','Y','Z','','','','','','','','','',
    '','','','','','','a','b','c','d','e','f','g','h','i','j','k','l',
    'm','n','o','p','q','r','s','t','u','v','w','x','y','z','','','','',
    '','','','','','','','','','',''];
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Form1.Width := 698;
  Form1.Height := 480; 
end;

end.
